﻿Public Class Form_main
    Const MAX_RECORD = &H20000 ' 1Mbit EEPROM x 4

    Dim file As System.IO.StreamWriter
    Dim first_data As Boolean = True
    Dim server_connected As Boolean = False
    Dim file_opened As Boolean = False
    Dim buf_read(100) As Char
    Dim buf_read_index As Integer = 0
    Dim last_seq_no As Long
    Dim last_seq_datetime As Date
    Dim interval As New TimeSpan(0, 0, 2)
    Dim seq_error As Boolean = False
    Dim last_seq_no_current As Long

    'Dim last_recieved_datetime As Date

    Private Sub Button_connect_Click(sender As System.Object, e As System.EventArgs) Handles Button_connect.Click
        Button_connect.Enabled = False
        If server_connected Then
            wattmeter_deactivate()
        Else
            wattmeter_activate()
        End If
        Button_connect.Enabled = True
    End Sub

    Delegate Sub WattTotalDelegate(ByVal str As String)
    Private Sub WattTotal(ByVal str As String)
        Label_watt.Text = str
    End Sub

    Delegate Sub WattCH1Delegate(ByVal watt_total As String)
    Private Sub Wattch1(ByVal str As String)
        Label_ch1.Text = "CH1=" + str + " W"
    End Sub

    Delegate Sub WattCH2Delegate(ByVal watt_total As String)
    Private Sub Wattch2(ByVal str As String)
        Label_ch2.Text = "CH2=" + str + " W"
    End Sub

    Delegate Sub SeqDelegate(ByVal seq As String)
    Private Sub seq(ByVal str As String)
        Label_seq.Text = "Record No=" + str
    End Sub

    Private Sub SystemEvents_PowerModeChanged(ByVal sender As Object, ByVal PowerModeChangedEvent As Microsoft.Win32.PowerModeChangedEventArgs)
        If PowerModeChangedEvent.Mode = Microsoft.Win32.PowerModes.Resume Then
            System.Threading.Thread.Sleep(5000) ' 速く起動されるとarduinoの準備が出来ていない
            wattmeter_activate()
        Else
            wattmeter_deactivate()
        End If
    End Sub

    Private Sub SerialPort1_DataReceived(sender As System.Object, e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        Dim buf_write(20) As Byte
        Dim rbytes As Integer

        Dim watt_totalMethod As New WattTotalDelegate(AddressOf WattTotal)
        Dim watt_CH1Method As New WattTotalDelegate(AddressOf Wattch1)
        Dim watt_CH2Method As New WattTotalDelegate(AddressOf Wattch2)
        Dim seq_Method As New SeqDelegate(AddressOf seq)

        Dim seq_no As Long
        Dim ch1_watt As String = ""
        Dim ch2_watt As String = ""
        Dim total_watt As Integer
        Dim total_watt_str As String = ""
        Dim out_str As String
        Dim counter As Byte
        Dim strarray As String()
        Dim records As Integer
        Dim last_seq_no_str As String

        Try
            'last_recieved_datetime = System.DateTime.Now
            rbytes = SerialPort1.BytesToRead
            While rbytes > 0 And SerialPort1.IsOpen
                buf_read(buf_read_index) = Chr(SerialPort1.ReadByte)
                If buf_read(buf_read_index) = "#" Then
                    Dim recive_string As New String(buf_read, 0, buf_read_index)
                    If buf_read(0) = "s" Then ' PC受信開始のACK
                        server_connected = True
                        buf_read_index = 0
                        Exit While
                    End If
                    If server_connected And file_opened Then
                        Select Case buf_read(0)
                            Case "D"  ' 電力および日時受信
                                strarray = recive_string.Split(",")
                                records = Integer.Parse(Mid(strarray(0), 2, 1))
                                seq_no = Long.Parse(Mid(strarray(0), 4))
                                If first_data Then
                                    first_data = False
                                    file.WriteLine("@seq=" & seq_no & " " & last_seq_no)
                                    If (last_seq_no + MAX_RECORD) > seq_no And seq_no > (last_seq_no + 1) Then
                                        last_seq_no_str = (last_seq_no + 1).ToString
                                        file.WriteLine("@req=" & last_seq_no_str)
                                        SerialPort1.Write("d" & last_seq_no_str & "#")
                                        seq_error = True
                                        buf_read_index = 0
                                        Exit While
                                    End If
                                End If
                                If seq_error And (seq_no = last_seq_no + 1) Then
                                    file.WriteLine("@ " & seq_no & " " & last_seq_no & " seq err kaijyo")
                                    seq_error = False
                                End If
                                For counter = 1 To records
                                    ch1_watt = strarray(counter * 2 - 1)
                                    ch2_watt = strarray(counter * 2)
                                    total_watt = Integer.Parse(ch1_watt) + Integer.Parse(ch2_watt)
                                    total_watt_str = Microsoft.VisualBasic.Right("    " + total_watt.ToString("0"), 4)
                                    out_str = seq_no.ToString + "," + ch1_watt + "," + ch2_watt
                                    If buf_read(2) = "T" Then
                                        out_str = out_str + "," + strarray(3) + ",SYNC"
                                        last_seq_datetime = Date.Parse(strarray(3))
                                        seq_error = False
                                        file.Flush()
                                    Else
                                        last_seq_datetime = last_seq_datetime + interval
                                        out_str = out_str + "," + last_seq_datetime.ToString("yyyy/MM/dd HH:mm:ss")
                                    End If
                                    If Not seq_error Then
                                        file.WriteLine(out_str)
                                    End If
                                    last_seq_no_current = seq_no
                                    seq_no = seq_no + 1
                                Next
                                Label_watt.Invoke(watt_totalMethod, total_watt_str)
                                Label_ch1.Invoke(watt_CH1Method, ch1_watt)
                                Label_ch2.Invoke(watt_CH2Method, ch2_watt)
                                Label_seq.Invoke(seq_Method, seq_no.ToString)
                            Case "T"  ' 時刻応答
                                SerialPort1.Write("t" + System.DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + "#")
                            Case "Q"  ' WatchDog
                                SerialPort1.Write("q#")
                            Case "w"
                                server_connected = False
                                SerialPort1.Close()
                                Exit Sub
                            Case Else
                                file.WriteLine("@" & recive_string)
                        End Select
                    End If
                    buf_read_index = 0
                Else
                    buf_read_index = buf_read_index + 1
                    rbytes = rbytes - 1
                End If
            End While
        Catch ex As System.IO.IOException
            file.Flush()
            set_ini()
            MsgBox("Arduinoと通信エラー" & vbCr & "プログラムを終了します", vbExclamation, "ERROR")
            Application.Exit()
        End Try
    End Sub

    Private Sub Form_main_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        wattmeter_activate()
        buf_read_index = 0
        'last_recieved_datetime = System.DateTime.Now
        'Timer1.Enabled = True
        AddHandler Microsoft.Win32.SystemEvents.PowerModeChanged, AddressOf SystemEvents_PowerModeChanged
    End Sub

    Private Sub wattmeter_activate()
        Dim fname As String = System.AppDomain.CurrentDomain.BaseDirectory & "data\raw.txt"
        file = My.Computer.FileSystem.OpenTextFileWriter(fname, True)
        file_opened = True
        last_seq_no = UInteger.Parse(get_ini("LAST_SEQ_NO"))
        last_seq_datetime = Date.Parse(get_ini("LAST_SEQ_TIME"))
        first_data = True

        If My.Computer.Ports.SerialPortNames.Count = 0 Then
            MsgBox("Arduinoが見つからない" & vbCr & "Arduinoを接続し直してプログラムを再起動", vbExclamation, "ERROR")
            Exit Sub
        Else
            For retry_couynter = 0 To 10 ' 数回リトライする
                For Each sp_name As String In My.Computer.Ports.SerialPortNames
                    SerialPort1.PortName = sp_name
                    Try
                        SerialPort1.Open()
                    Catch ex As UnauthorizedAccessException
                        Continue For
                    End Try
                    buf_read_index = 0
                    SerialPort1.DiscardInBuffer()
                    SerialPort1.Write("S#S#")
                    System.Threading.Thread.Sleep(1000)
                    Application.DoEvents()
                    If server_connected Then
                        Button_connect.BackColor = Color.LightGreen 'ボタンを緑にする
                        Button_connect.Text = sp_name
                        Exit Sub
                    End If
                    SerialPort1.Close()
                Next
            Next
            MsgBox("Wattmeterが見つからない" & vbCr & "Arduinoを接続し直してプログラムを再起動", vbExclamation, "ERROR")
        End If
    End Sub

    Private Sub wattmeter_deactivate()
        If SerialPort1.IsOpen Then
            Button_connect.BackColor = Color.LightCoral 'ボタンを赤くする
            Button_connect.Text = "----"
            SerialPort1.Write("W#W#")
            Application.DoEvents()
            System.Threading.Thread.Sleep(1000)
            Application.DoEvents()
        End If
        If file_opened Then
            file.WriteLine("@************************************************")
            file.Close()
            file_opened = False
        End If
        set_ini()
        first_data = True
    End Sub

    Private Function get_ini(keyword As String) As String
        Dim arr() As String = {"", ""}
        Dim ini_file As FileIO.TextFieldParser
        Dim fname As String
        Dim key_value As String = ""

        fname = System.AppDomain.CurrentDomain.BaseDirectory + "\wattmeter.ini"
        If System.IO.File.Exists(fname) Then
            ini_file = My.Computer.FileSystem.OpenTextFieldParser(fname, ",")
            While Not ini_file.EndOfData
                arr = ini_file.ReadFields
                If arr(0) = keyword Then
                    key_value = arr(1)
                    Exit While
                End If
            End While
            ini_file.Close()
        Else
            Select Case keyword
                Case "LAST_SEQ_NO"
                    key_value = "1"
                Case "LAST_SEQ_TIME"
                    key_value = Date.Now.ToString("yyyy/MM/dd HH:mm:ss")
            End Select
        End If

        Return key_value
    End Function

    Private Sub set_ini()
        Dim ini_file As System.IO.StreamWriter
        Dim pgmdir As String

        pgmdir = System.AppDomain.CurrentDomain.BaseDirectory
        If last_seq_no_current <> 0 Then
            ini_file = My.Computer.FileSystem.OpenTextFileWriter(pgmdir + "\wattmeter.ini", False)
            ini_file.WriteLine("LAST_SEQ_NO," & last_seq_no_current)
            ini_file.WriteLine("LAST_SEQ_TIME," & last_seq_datetime.ToString("yyyy/MM/dd HH:mm:ss"))
            ini_file.Close()
        End If
    End Sub

    Private Sub Form_main_FormClosing(sender As System.Object, e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        wattmeter_deactivate()
    End Sub

    'Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
    '    If (System.DateTime.Now - last_recieved_datetime).TotalSeconds > 10 Then
    '        file.Flush()
    '        set_ini()
    '        MsgBox("Arduinoが応答しなくなった" & vbCr & "Arduinoを接続し直してプログラムを再起動", vbExclamation, "ERROR")
    '    End If
    'End Sub
End Class
